import { warning as N } from "../../../utils/errors.mjs";
import { clamp as h } from "../../../utils/clamp.mjs";
import { secondsToMilliseconds as g, millisecondsToSeconds as T } from "../../../utils/time-conversion.mjs";
const M = 1e-3, A = 0.01, D = 10, G = 0.05, I = 1;
function E({ duration: t = 800, bounce: i = 0.25, velocity: c = 0, mass: o = 1 }) {
  let a, p;
  N(t <= g(D), "Spring duration must be 10 seconds or less");
  let s = 1 - i;
  s = h(G, I, s), t = h(A, D, T(t)), s < 1 ? (a = (n) => {
    const r = n * s, e = r * t, l = r - c, f = w(n, s), m = Math.exp(-e);
    return M - l / f * m;
  }, p = (n) => {
    const e = n * s * t, l = e * c + c, f = Math.pow(s, 2) * Math.pow(n, 2) * t, m = Math.exp(-e), S = w(Math.pow(n, 2), s);
    return (-a(n) + M > 0 ? -1 : 1) * ((l - f) * m) / S;
  }) : (a = (n) => {
    const r = Math.exp(-n * t), e = (n - c) * t + 1;
    return -M + r * e;
  }, p = (n) => {
    const r = Math.exp(-n * t), e = (c - n) * (t * t);
    return r * e;
  });
  const b = 5 / t, x = j(a, p, b);
  if (t = g(t), isNaN(x))
    return {
      stiffness: 100,
      damping: 10,
      duration: t
    };
  {
    const n = Math.pow(x, 2) * o;
    return {
      stiffness: n,
      damping: s * 2 * Math.sqrt(o * n),
      duration: t
    };
  }
}
const R = 12;
function j(t, i, c) {
  let o = c;
  for (let a = 1; a < R; a++)
    o = o - t(o) / i(o);
  return o;
}
function w(t, i) {
  return t * Math.sqrt(1 - i * i);
}
export {
  w as calcAngularFreq,
  E as findSpring,
  I as maxDamping,
  D as maxDuration,
  G as minDamping,
  A as minDuration
};
