import { invariant as t } from "../../utils/errors.mjs";
import { cubicBezier as u } from "../cubic-bezier.mjs";
import { noop as m } from "../../utils/noop.mjs";
import { easeIn as s, easeInOut as i, easeOut as p } from "../ease.mjs";
import { circIn as y, circInOut as I, circOut as b } from "../circ.mjs";
import { backIn as f, backInOut as l, backOut as O } from "../back.mjs";
import { anticipate as g } from "../anticipate.mjs";
const a = {
  linear: m,
  easeIn: s,
  easeInOut: i,
  easeOut: p,
  circIn: y,
  circInOut: I,
  circOut: b,
  backIn: f,
  backInOut: l,
  backOut: O,
  anticipate: g
}, C = (r) => {
  if (Array.isArray(r)) {
    t(r.length === 4, "Cubic bezier arrays must contain four numerical values.");
    const [e, o, c, n] = r;
    return u(e, o, c, n);
  } else if (typeof r == "string")
    return t(a[r] !== void 0, `Invalid easing type '${r}'`), a[r];
  return r;
};
export {
  C as easingDefinitionToFunction
};
