import { invariant as y } from "../../utils/errors.mjs";
import { PanSession as L } from "../pan/PanSession.mjs";
import { getGlobalLock as x } from "./utils/lock.mjs";
import { isRefObject as v } from "../../utils/is-ref-object.mjs";
import { addPointerEvent as M } from "../../events/add-pointer-event.mjs";
import { applyConstraints as V, calcRelativeConstraints as b, resolveDragElastic as S, calcViewportConstraints as B, rebaseAxisConstraints as k, calcOrigin as j, defaultElastic as G } from "./utils/constraints.mjs";
import { createBox as T } from "../../projection/geometry/models.mjs";
import { eachAxis as g } from "../../projection/utils/each-axis.mjs";
import { measurePageBox as w } from "../../projection/utils/measure.mjs";
import { extractEventInfo as R } from "../../events/event-info.mjs";
import { convertBoxToBoundingBox as O, convertBoundingBoxToBox as U } from "../../projection/geometry/conversion.mjs";
import { addDomEvent as W } from "../../events/add-dom-event.mjs";
import { calcLength as z } from "../../projection/geometry/delta-calc.mjs";
import { mix as D } from "../../utils/mix.mjs";
import { percent as I } from "../../value/types/numbers/units.mjs";
import { animateMotionValue as _ } from "../../animation/interfaces/motion-value.mjs";
import { frame as A } from "../../frameloop/frame.mjs";
const F = /* @__PURE__ */ new WeakMap();
class ct {
  constructor(t) {
    this.openGlobalLock = null, this.isDragging = !1, this.currentDirection = null, this.originPoint = { x: 0, y: 0 }, this.constraints = !1, this.hasMutatedConstraints = !1, this.elastic = T(), this.visualElement = t;
  }
  start(t, { snapToCursor: n = !1 } = {}) {
    const { presenceContext: s } = this.visualElement;
    if (s && s.isPresent === !1)
      return;
    const i = (r) => {
      this.stopAnimation(), n && this.snapToCursor(R(r, "page").point);
    }, e = (r, l) => {
      const { drag: c, dragPropagation: u, onDragStart: p } = this.getProps();
      if (c && !u && (this.openGlobalLock && this.openGlobalLock(), this.openGlobalLock = x(c), !this.openGlobalLock))
        return;
      this.isDragging = !0, this.currentDirection = null, this.resolveConstraints(), this.visualElement.projection && (this.visualElement.projection.isAnimationBlocked = !0, this.visualElement.projection.target = void 0), g((h) => {
        let d = this.getAxisMotionValue(h).get() || 0;
        if (I.test(d)) {
          const { projection: P } = this.visualElement;
          if (P && P.layout) {
            const C = P.layout.layoutBox[h];
            C && (d = z(C) * (parseFloat(d) / 100));
          }
        }
        this.originPoint[h] = d;
      }), p && A.update(() => p(r, l), !1, !0);
      const { animationState: m } = this.visualElement;
      m && m.setActive("whileDrag", !0);
    }, o = (r, l) => {
      const { dragPropagation: c, dragDirectionLock: u, onDirectionLock: p, onDrag: m } = this.getProps();
      if (!c && !this.openGlobalLock)
        return;
      const { offset: h } = l;
      if (u && this.currentDirection === null) {
        this.currentDirection = K(h), this.currentDirection !== null && p && p(this.currentDirection);
        return;
      }
      this.updateAxis("x", l.point, h), this.updateAxis("y", l.point, h), this.visualElement.render(), m && m(r, l);
    }, a = (r, l) => this.stop(r, l);
    this.panSession = new L(t, {
      onSessionStart: i,
      onStart: e,
      onMove: o,
      onSessionEnd: a
    }, { transformPagePoint: this.visualElement.getTransformPagePoint() });
  }
  stop(t, n) {
    const s = this.isDragging;
    if (this.cancel(), !s)
      return;
    const { velocity: i } = n;
    this.startAnimation(i);
    const { onDragEnd: e } = this.getProps();
    e && A.update(() => e(t, n));
  }
  cancel() {
    this.isDragging = !1;
    const { projection: t, animationState: n } = this.visualElement;
    t && (t.isAnimationBlocked = !1), this.panSession && this.panSession.end(), this.panSession = void 0;
    const { dragPropagation: s } = this.getProps();
    !s && this.openGlobalLock && (this.openGlobalLock(), this.openGlobalLock = null), n && n.setActive("whileDrag", !1);
  }
  updateAxis(t, n, s) {
    const { drag: i } = this.getProps();
    if (!s || !E(t, i, this.currentDirection))
      return;
    const e = this.getAxisMotionValue(t);
    let o = this.originPoint[t] + s[t];
    this.constraints && this.constraints[t] && (o = V(o, this.constraints[t], this.elastic[t])), e.set(o);
  }
  resolveConstraints() {
    const { dragConstraints: t, dragElastic: n } = this.getProps(), { layout: s } = this.visualElement.projection || {}, i = this.constraints;
    t && v(t) ? this.constraints || (this.constraints = this.resolveRefConstraints()) : t && s ? this.constraints = b(s.layoutBox, t) : this.constraints = !1, this.elastic = S(n), i !== this.constraints && s && this.constraints && !this.hasMutatedConstraints && g((e) => {
      this.getAxisMotionValue(e) && (this.constraints[e] = k(s.layoutBox[e], this.constraints[e]));
    });
  }
  resolveRefConstraints() {
    const { dragConstraints: t, onMeasureDragConstraints: n } = this.getProps();
    if (!t || !v(t))
      return !1;
    const s = t.current;
    y(s !== null, "If `dragConstraints` is set as a React ref, that ref must be passed to another component's `ref` prop.");
    const { projection: i } = this.visualElement;
    if (!i || !i.layout)
      return !1;
    const e = w(s, i.root, this.visualElement.getTransformPagePoint());
    let o = B(i.layout.layoutBox, e);
    if (n) {
      const a = n(O(o));
      this.hasMutatedConstraints = !!a, a && (o = U(a));
    }
    return o;
  }
  startAnimation(t) {
    const { drag: n, dragMomentum: s, dragElastic: i, dragTransition: e, dragSnapToOrigin: o, onDragTransitionEnd: a } = this.getProps(), r = this.constraints || {}, l = g((c) => {
      if (!E(c, n, this.currentDirection))
        return;
      let u = r && r[c] || {};
      o && (u = { min: 0, max: 0 });
      const p = i ? 200 : 1e6, m = i ? 40 : 1e7, h = {
        type: "inertia",
        velocity: s ? t[c] : 0,
        bounceStiffness: p,
        bounceDamping: m,
        timeConstant: 750,
        restDelta: 1,
        restSpeed: 10,
        ...e,
        ...u
      };
      return this.startAxisValueAnimation(c, h);
    });
    return Promise.all(l).then(a);
  }
  startAxisValueAnimation(t, n) {
    const s = this.getAxisMotionValue(t);
    return s.start(_(t, s, 0, n));
  }
  stopAnimation() {
    g((t) => this.getAxisMotionValue(t).stop());
  }
  /**
   * Drag works differently depending on which props are provided.
   *
   * - If _dragX and _dragY are provided, we output the gesture delta directly to those motion values.
   * - Otherwise, we apply the delta to the x/y motion values.
   */
  getAxisMotionValue(t) {
    const n = "_drag" + t.toUpperCase(), s = this.visualElement.getProps(), i = s[n];
    return i || this.visualElement.getValue(t, (s.initial ? s.initial[t] : void 0) || 0);
  }
  snapToCursor(t) {
    g((n) => {
      const { drag: s } = this.getProps();
      if (!E(n, s, this.currentDirection))
        return;
      const { projection: i } = this.visualElement, e = this.getAxisMotionValue(n);
      if (i && i.layout) {
        const { min: o, max: a } = i.layout.layoutBox[n];
        e.set(t[n] - D(o, a, 0.5));
      }
    });
  }
  /**
   * When the viewport resizes we want to check if the measured constraints
   * have changed and, if so, reposition the element within those new constraints
   * relative to where it was before the resize.
   */
  scalePositionWithinConstraints() {
    if (!this.visualElement.current)
      return;
    const { drag: t, dragConstraints: n } = this.getProps(), { projection: s } = this.visualElement;
    if (!v(n) || !s || !this.constraints)
      return;
    this.stopAnimation();
    const i = { x: 0, y: 0 };
    g((o) => {
      const a = this.getAxisMotionValue(o);
      if (a) {
        const r = a.get();
        i[o] = j({ min: r, max: r }, this.constraints[o]);
      }
    });
    const { transformTemplate: e } = this.visualElement.getProps();
    this.visualElement.current.style.transform = e ? e({}, "") : "none", s.root && s.root.updateScroll(), s.updateLayout(), this.resolveConstraints(), g((o) => {
      if (!E(o, t, null))
        return;
      const a = this.getAxisMotionValue(o), { min: r, max: l } = this.constraints[o];
      a.set(D(r, l, i[o]));
    });
  }
  addListeners() {
    if (!this.visualElement.current)
      return;
    F.set(this.visualElement, this);
    const t = this.visualElement.current, n = M(t, "pointerdown", (r) => {
      const { drag: l, dragListener: c = !0 } = this.getProps();
      l && c && this.start(r);
    }), s = () => {
      const { dragConstraints: r } = this.getProps();
      v(r) && (this.constraints = this.resolveRefConstraints());
    }, { projection: i } = this.visualElement, e = i.addEventListener("measure", s);
    i && !i.layout && (i.root && i.root.updateScroll(), i.updateLayout()), s();
    const o = W(window, "resize", () => this.scalePositionWithinConstraints()), a = i.addEventListener("didUpdate", ({ delta: r, hasLayoutChanged: l }) => {
      this.isDragging && l && (g((c) => {
        const u = this.getAxisMotionValue(c);
        u && (this.originPoint[c] += r[c].translate, u.set(u.get() + r[c].translate));
      }), this.visualElement.render());
    });
    return () => {
      o(), n(), e(), a && a();
    };
  }
  getProps() {
    const t = this.visualElement.getProps(), { drag: n = !1, dragDirectionLock: s = !1, dragPropagation: i = !1, dragConstraints: e = !1, dragElastic: o = G, dragMomentum: a = !0 } = t;
    return {
      ...t,
      drag: n,
      dragDirectionLock: s,
      dragPropagation: i,
      dragConstraints: e,
      dragElastic: o,
      dragMomentum: a
    };
  }
}
function E(f, t, n) {
  return (t === !0 || t === f) && (n === null || n === f);
}
function K(f, t = 10) {
  let n = null;
  return Math.abs(f.y) > t ? n = "y" : Math.abs(f.x) > t && (n = "x"), n;
}
export {
  ct as VisualElementDragControls,
  F as elementDragControls
};
