import d, { useContext as p } from "react";
import { usePresence as m } from "../../../components/AnimatePresence/use-presence.mjs";
import { LayoutGroupContext as c } from "../../../context/LayoutGroupContext.mjs";
import { SwitchLayoutGroupContext as f } from "../../../context/SwitchLayoutGroupContext.mjs";
import { globalProjectionState as l } from "../../../projection/node/state.mjs";
import { correctBorderRadius as n } from "../../../projection/styles/scale-border-radius.mjs";
import { correctBoxShadow as h } from "../../../projection/styles/scale-box-shadow.mjs";
import { addScaleCorrector as R } from "../../../projection/styles/scale-correction.mjs";
import { frame as g } from "../../../frameloop/frame.mjs";
class y extends d.Component {
  /**
   * This only mounts projection nodes for components that
   * need measuring, we might want to do it for all components
   * in order to incorporate transforms
   */
  componentDidMount() {
    const { visualElement: e, layoutGroup: o, switchLayoutGroup: t, layoutId: i } = this.props, { projection: r } = e;
    R(v), r && (o.group && o.group.add(r), t && t.register && i && t.register(r), r.root.didUpdate(), r.addEventListener("animationComplete", () => {
      this.safeToRemove();
    }), r.setOptions({
      ...r.options,
      onExitComplete: () => this.safeToRemove()
    })), l.hasEverUpdated = !0;
  }
  getSnapshotBeforeUpdate(e) {
    const { layoutDependency: o, visualElement: t, drag: i, isPresent: r } = this.props, s = t.projection;
    return s && (s.isPresent = r, i || e.layoutDependency !== o || o === void 0 ? s.willUpdate() : this.safeToRemove(), e.isPresent !== r && (r ? s.promote() : s.relegate() || g.postRender(() => {
      const u = s.getStack();
      (!u || !u.members.length) && this.safeToRemove();
    }))), null;
  }
  componentDidUpdate() {
    const { projection: e } = this.props.visualElement;
    e && (e.root.didUpdate(), queueMicrotask(() => {
      !e.currentAnimation && e.isLead() && this.safeToRemove();
    }));
  }
  componentWillUnmount() {
    const { visualElement: e, layoutGroup: o, switchLayoutGroup: t } = this.props, { projection: i } = e;
    i && (i.scheduleCheckAfterUnmount(), o && o.group && o.group.remove(i), t && t.deregister && t.deregister(i));
  }
  safeToRemove() {
    const { safeToRemove: e } = this.props;
    e && e();
  }
  render() {
    return null;
  }
}
function w(a) {
  const [e, o] = m(), t = p(c);
  return d.createElement(y, { ...a, layoutGroup: t, switchLayoutGroup: p(f), isPresent: e, safeToRemove: o });
}
const v = {
  borderRadius: {
    ...n,
    applyTo: [
      "borderTopLeftRadius",
      "borderTopRightRadius",
      "borderBottomLeftRadius",
      "borderBottomRightRadius"
    ]
  },
  borderTopLeftRadius: n,
  borderTopRightRadius: n,
  borderBottomLeftRadius: n,
  borderBottomRightRadius: n,
  boxShadow: h
};
export {
  w as MeasureLayout
};
