import { SubscriptionManager as st } from "../../utils/subscription-manager.mjs";
import { mixValues as ot } from "../animation/mix-values.mjs";
import { copyBoxInto as p } from "../geometry/copy.mjs";
import { translateAxis as S, transformBox as k, applyBoxDelta as at, applyTreeDeltas as rt } from "../geometry/delta-apply.mjs";
import { calcRelativePosition as A, calcRelativeBox as nt, calcBoxDelta as L, calcLength as E, isNear as lt } from "../geometry/delta-calc.mjs";
import { removeBoxTransforms as w } from "../geometry/delta-remove.mjs";
import { createBox as f, createDelta as j } from "../geometry/models.mjs";
import { getValueTransition as ht } from "../../animation/utils/transitions.mjs";
import { boxEqualsRounded as tt, isDeltaZero as et, aspectRatio as I, boxEquals as ut } from "../geometry/utils.mjs";
import { NodeStack as ct } from "../shared/stack.mjs";
import { scaleCorrectors as N } from "../styles/scale-correction.mjs";
import { buildProjectionTransform as W } from "../styles/transform.mjs";
import { eachAxis as z } from "../utils/each-axis.mjs";
import { hasTransform as B, hasScale as _, has2DTranslate as dt } from "../utils/has-transform.mjs";
import { FlatTree as ft } from "../../render/utils/flat-tree.mjs";
import { resolveMotionValue as C } from "../../value/utils/resolve-motion-value.mjs";
import { globalProjectionState as O } from "./state.mjs";
import { delay as mt } from "../../utils/delay.mjs";
import { mix as F } from "../../utils/mix.mjs";
import { record as pt } from "../../debug/record.mjs";
import { isSVGElement as yt } from "../../render/dom/utils/is-svg-element.mjs";
import { animateSingleValue as gt } from "../../animation/interfaces/single-value.mjs";
import { clamp as vt } from "../../utils/clamp.mjs";
import { cancelFrame as H, frameData as y, steps as b, frame as M } from "../../frameloop/frame.mjs";
import { noop as Tt } from "../../utils/noop.mjs";
const q = ["", "X", "Y", "Z"], G = 1e3;
let xt = 0;
const x = {
  type: "projectionFrame",
  totalNodes: 0,
  resolvedTargetDeltas: 0,
  recalculatedProjection: 0
};
function le({ attachResizeListener: i, defaultParent: u, measureScroll: h, checkIsScrollRoot: d, resetTransform: V }) {
  return class {
    constructor(t = {}, e = u == null ? void 0 : u()) {
      this.id = xt++, this.animationId = 0, this.children = /* @__PURE__ */ new Set(), this.options = {}, this.isTreeAnimating = !1, this.isAnimationBlocked = !1, this.isLayoutDirty = !1, this.isProjectionDirty = !1, this.isSharedProjectionDirty = !1, this.isTransformDirty = !1, this.updateManuallyBlocked = !1, this.updateBlockedByResize = !1, this.isUpdating = !1, this.isSVG = !1, this.needsReset = !1, this.shouldResetTransform = !1, this.treeScale = { x: 1, y: 1 }, this.eventHandlers = /* @__PURE__ */ new Map(), this.hasTreeAnimated = !1, this.updateScheduled = !1, this.checkUpdateFailed = () => {
        this.isUpdating && (this.isUpdating = !1, this.clearAllSnapshots());
      }, this.updateProjection = () => {
        x.totalNodes = x.resolvedTargetDeltas = x.recalculatedProjection = 0, this.nodes.forEach(St), this.nodes.forEach(Lt), this.nodes.forEach(Vt), this.nodes.forEach(Bt), pt(x);
      }, this.hasProjected = !1, this.isVisible = !0, this.animationProgress = 0, this.sharedNodes = /* @__PURE__ */ new Map(), this.latestValues = t, this.root = e ? e.root || e : this, this.path = e ? [...e.path, e] : [], this.parent = e, this.depth = e ? e.depth + 1 : 0;
      for (let s = 0; s < this.path.length; s++)
        this.path[s].shouldResetTransform = !0;
      this.root === this && (this.nodes = new ft());
    }
    addEventListener(t, e) {
      return this.eventHandlers.has(t) || this.eventHandlers.set(t, new st()), this.eventHandlers.get(t).add(e);
    }
    notifyListeners(t, ...e) {
      const s = this.eventHandlers.get(t);
      s && s.notify(...e);
    }
    hasListeners(t) {
      return this.eventHandlers.has(t);
    }
    /**
     * Lifecycles
     */
    mount(t, e = this.root.hasTreeAnimated) {
      if (this.instance)
        return;
      this.isSVG = yt(t), this.instance = t;
      const { layoutId: s, layout: o, visualElement: a } = this.options;
      if (a && !a.current && a.mount(t), this.root.nodes.add(this), this.parent && this.parent.children.add(this), e && (o || s) && (this.isLayoutDirty = !0), i) {
        let r;
        const n = () => this.root.updateBlockedByResize = !1;
        i(t, () => {
          this.root.updateBlockedByResize = !0, r && r(), r = mt(n, 250), O.hasAnimatedSinceResize && (O.hasAnimatedSinceResize = !1, this.nodes.forEach(Y));
        });
      }
      s && this.root.registerSharedNode(s, this), this.options.animate !== !1 && a && (s || o) && this.addEventListener("didUpdate", ({ delta: r, hasLayoutChanged: n, hasRelativeTargetChanged: l, layout: m }) => {
        if (this.isTreeAnimationBlocked()) {
          this.target = void 0, this.relativeTarget = void 0;
          return;
        }
        const c = this.options.transition || a.getDefaultTransition() || Ct, { onLayoutAnimationStart: P, onLayoutAnimationComplete: T } = a.getProps(), D = !this.targetLayout || !tt(this.targetLayout, m) || l, g = !n && l;
        if (this.options.layoutRoot || this.resumeFrom && this.resumeFrom.instance || g || n && (D || !this.currentAnimation)) {
          this.resumeFrom && (this.resumingFrom = this.resumeFrom, this.resumingFrom.resumingFrom = void 0), this.setAnimationOrigin(r, g);
          const v = {
            ...ht(c, "layout"),
            onPlay: P,
            onComplete: T
          };
          (a.shouldReduceMotion || this.options.layoutRoot) && (v.delay = 0, v.type = !1), this.startAnimation(v);
        } else
          n || Y(this), this.isLead() && this.options.onExitComplete && this.options.onExitComplete();
        this.targetLayout = m;
      });
    }
    unmount() {
      this.options.layoutId && this.willUpdate(), this.root.nodes.remove(this);
      const t = this.getStack();
      t && t.remove(this), this.parent && this.parent.children.delete(this), this.instance = void 0, H(this.updateProjection);
    }
    // only on the root
    blockUpdate() {
      this.updateManuallyBlocked = !0;
    }
    unblockUpdate() {
      this.updateManuallyBlocked = !1;
    }
    isUpdateBlocked() {
      return this.updateManuallyBlocked || this.updateBlockedByResize;
    }
    isTreeAnimationBlocked() {
      return this.isAnimationBlocked || this.parent && this.parent.isTreeAnimationBlocked() || !1;
    }
    // Note: currently only running on root node
    startUpdate() {
      this.isUpdateBlocked() || (this.isUpdating = !0, this.nodes && this.nodes.forEach(kt), this.animationId++);
    }
    getTransformTemplate() {
      const { visualElement: t } = this.options;
      return t && t.getProps().transformTemplate;
    }
    willUpdate(t = !0) {
      if (this.root.hasTreeAnimated = !0, this.root.isUpdateBlocked()) {
        this.options.onExitComplete && this.options.onExitComplete();
        return;
      }
      if (!this.root.isUpdating && this.root.startUpdate(), this.isLayoutDirty)
        return;
      this.isLayoutDirty = !0;
      for (let a = 0; a < this.path.length; a++) {
        const r = this.path[a];
        r.shouldResetTransform = !0, r.updateScroll("snapshot"), r.options.layoutRoot && r.willUpdate(!1);
      }
      const { layoutId: e, layout: s } = this.options;
      if (e === void 0 && !s)
        return;
      const o = this.getTransformTemplate();
      this.prevTransformTemplateValue = o ? o(this.latestValues, "") : void 0, this.updateSnapshot(), t && this.notifyListeners("willUpdate");
    }
    update() {
      if (this.updateScheduled = !1, this.isUpdateBlocked()) {
        this.unblockUpdate(), this.clearAllSnapshots(), this.nodes.forEach(X);
        return;
      }
      this.isUpdating || this.nodes.forEach(Rt), this.isUpdating = !1, this.nodes.forEach(At), this.nodes.forEach(Pt), this.nodes.forEach(Dt), this.clearAllSnapshots();
      const e = performance.now();
      y.delta = vt(0, 1e3 / 60, e - y.timestamp), y.timestamp = e, y.isProcessing = !0, b.update.process(y), b.preRender.process(y), b.render.process(y), y.isProcessing = !1;
    }
    didUpdate() {
      this.updateScheduled || (this.updateScheduled = !0, queueMicrotask(() => this.update()));
    }
    clearAllSnapshots() {
      this.nodes.forEach(jt), this.sharedNodes.forEach(Et);
    }
    scheduleUpdateProjection() {
      M.preRender(this.updateProjection, !1, !0);
    }
    scheduleCheckAfterUnmount() {
      M.postRender(() => {
        this.isLayoutDirty ? this.root.didUpdate() : this.root.checkUpdateFailed();
      });
    }
    /**
     * Update measurements
     */
    updateSnapshot() {
      this.snapshot || !this.instance || (this.snapshot = this.measure());
    }
    updateLayout() {
      if (!this.instance || (this.updateScroll(), !(this.options.alwaysMeasureLayout && this.isLead()) && !this.isLayoutDirty))
        return;
      if (this.resumeFrom && !this.resumeFrom.instance)
        for (let s = 0; s < this.path.length; s++)
          this.path[s].updateScroll();
      const t = this.layout;
      this.layout = this.measure(!1), this.layoutCorrected = f(), this.isLayoutDirty = !1, this.projectionDelta = void 0, this.notifyListeners("measure", this.layout.layoutBox);
      const { visualElement: e } = this.options;
      e && e.notify("LayoutMeasure", this.layout.layoutBox, t ? t.layoutBox : void 0);
    }
    updateScroll(t = "measure") {
      let e = !!(this.options.layoutScroll && this.instance);
      this.scroll && this.scroll.animationId === this.root.animationId && this.scroll.phase === t && (e = !1), e && (this.scroll = {
        animationId: this.root.animationId,
        phase: t,
        isRoot: d(this.instance),
        offset: h(this.instance)
      });
    }
    resetTransform() {
      if (!V)
        return;
      const t = this.isLayoutDirty || this.shouldResetTransform, e = this.projectionDelta && !et(this.projectionDelta), s = this.getTransformTemplate(), o = s ? s(this.latestValues, "") : void 0, a = o !== this.prevTransformTemplateValue;
      t && (e || B(this.latestValues) || a) && (V(this.instance, o), this.shouldResetTransform = !1, this.scheduleRender());
    }
    measure(t = !0) {
      const e = this.measurePageBox();
      let s = this.removeElementScroll(e);
      return t && (s = this.removeTransform(s)), Ot(s), {
        animationId: this.root.animationId,
        measuredBox: e,
        layoutBox: s,
        latestValues: {},
        source: this.id
      };
    }
    measurePageBox() {
      const { visualElement: t } = this.options;
      if (!t)
        return f();
      const e = t.measureViewportBox(), { scroll: s } = this.root;
      return s && (S(e.x, s.offset.x), S(e.y, s.offset.y)), e;
    }
    removeElementScroll(t) {
      const e = f();
      p(e, t);
      for (let s = 0; s < this.path.length; s++) {
        const o = this.path[s], { scroll: a, options: r } = o;
        if (o !== this.root && a && r.layoutScroll) {
          if (a.isRoot) {
            p(e, t);
            const { scroll: n } = this.root;
            n && (S(e.x, -n.offset.x), S(e.y, -n.offset.y));
          }
          S(e.x, a.offset.x), S(e.y, a.offset.y);
        }
      }
      return e;
    }
    applyTransform(t, e = !1) {
      const s = f();
      p(s, t);
      for (let o = 0; o < this.path.length; o++) {
        const a = this.path[o];
        !e && a.options.layoutScroll && a.scroll && a !== a.root && k(s, {
          x: -a.scroll.offset.x,
          y: -a.scroll.offset.y
        }), B(a.latestValues) && k(s, a.latestValues);
      }
      return B(this.latestValues) && k(s, this.latestValues), s;
    }
    removeTransform(t) {
      const e = f();
      p(e, t);
      for (let s = 0; s < this.path.length; s++) {
        const o = this.path[s];
        if (!o.instance || !B(o.latestValues))
          continue;
        _(o.latestValues) && o.updateSnapshot();
        const a = f(), r = o.measurePageBox();
        p(a, r), w(e, o.latestValues, o.snapshot ? o.snapshot.layoutBox : void 0, a);
      }
      return B(this.latestValues) && w(e, this.latestValues), e;
    }
    setTargetDelta(t) {
      this.targetDelta = t, this.root.scheduleUpdateProjection(), this.isProjectionDirty = !0;
    }
    setOptions(t) {
      this.options = {
        ...this.options,
        ...t,
        crossfade: t.crossfade !== void 0 ? t.crossfade : !0
      };
    }
    clearMeasurements() {
      this.scroll = void 0, this.layout = void 0, this.snapshot = void 0, this.prevTransformTemplateValue = void 0, this.targetDelta = void 0, this.target = void 0, this.isLayoutDirty = !1;
    }
    forceRelativeParentToResolveTarget() {
      this.relativeParent && this.relativeParent.resolvedRelativeTargetAt !== y.timestamp && this.relativeParent.resolveTargetDelta(!0);
    }
    resolveTargetDelta(t = !1) {
      var e;
      const s = this.getLead();
      this.isProjectionDirty || (this.isProjectionDirty = s.isProjectionDirty), this.isTransformDirty || (this.isTransformDirty = s.isTransformDirty), this.isSharedProjectionDirty || (this.isSharedProjectionDirty = s.isSharedProjectionDirty);
      const o = !!this.resumingFrom || this !== s;
      if (!(t || o && this.isSharedProjectionDirty || this.isProjectionDirty || !((e = this.parent) === null || e === void 0) && e.isProjectionDirty || this.attemptToResolveRelativeTarget))
        return;
      const { layout: r, layoutId: n } = this.options;
      if (!(!this.layout || !(r || n))) {
        if (this.resolvedRelativeTargetAt = y.timestamp, !this.targetDelta && !this.relativeTarget) {
          const l = this.getClosestProjectingParent();
          l && l.layout && this.animationProgress !== 1 ? (this.relativeParent = l, this.forceRelativeParentToResolveTarget(), this.relativeTarget = f(), this.relativeTargetOrigin = f(), A(this.relativeTargetOrigin, this.layout.layoutBox, l.layout.layoutBox), p(this.relativeTarget, this.relativeTargetOrigin)) : this.relativeParent = this.relativeTarget = void 0;
        }
        if (!(!this.relativeTarget && !this.targetDelta)) {
          if (this.target || (this.target = f(), this.targetWithTransforms = f()), this.relativeTarget && this.relativeTargetOrigin && this.relativeParent && this.relativeParent.target ? (this.forceRelativeParentToResolveTarget(), nt(this.target, this.relativeTarget, this.relativeParent.target)) : this.targetDelta ? (this.resumingFrom ? this.target = this.applyTransform(this.layout.layoutBox) : p(this.target, this.layout.layoutBox), at(this.target, this.targetDelta)) : p(this.target, this.layout.layoutBox), this.attemptToResolveRelativeTarget) {
            this.attemptToResolveRelativeTarget = !1;
            const l = this.getClosestProjectingParent();
            l && !!l.resumingFrom == !!this.resumingFrom && !l.options.layoutScroll && l.target && this.animationProgress !== 1 ? (this.relativeParent = l, this.forceRelativeParentToResolveTarget(), this.relativeTarget = f(), this.relativeTargetOrigin = f(), A(this.relativeTargetOrigin, this.target, l.target), p(this.relativeTarget, this.relativeTargetOrigin)) : this.relativeParent = this.relativeTarget = void 0;
          }
          x.resolvedTargetDeltas++;
        }
      }
    }
    getClosestProjectingParent() {
      if (!(!this.parent || _(this.parent.latestValues) || dt(this.parent.latestValues)))
        return this.parent.isProjecting() ? this.parent : this.parent.getClosestProjectingParent();
    }
    isProjecting() {
      return !!((this.relativeTarget || this.targetDelta || this.options.layoutRoot) && this.layout);
    }
    calcProjection() {
      var t;
      const e = this.getLead(), s = !!this.resumingFrom || this !== e;
      let o = !0;
      if ((this.isProjectionDirty || !((t = this.parent) === null || t === void 0) && t.isProjectionDirty) && (o = !1), s && (this.isSharedProjectionDirty || this.isTransformDirty) && (o = !1), this.resolvedRelativeTargetAt === y.timestamp && (o = !1), o)
        return;
      const { layout: a, layoutId: r } = this.options;
      if (this.isTreeAnimating = !!(this.parent && this.parent.isTreeAnimating || this.currentAnimation || this.pendingAnimation), this.isTreeAnimating || (this.targetDelta = this.relativeTarget = void 0), !this.layout || !(a || r))
        return;
      p(this.layoutCorrected, this.layout.layoutBox);
      const n = this.treeScale.x, l = this.treeScale.y;
      rt(this.layoutCorrected, this.treeScale, this.path, s), e.layout && !e.target && (this.treeScale.x !== 1 || this.treeScale.y !== 1) && (e.target = e.layout.layoutBox);
      const { target: m } = e;
      if (!m) {
        this.projectionTransform && (this.projectionDelta = j(), this.projectionTransform = "none", this.scheduleRender());
        return;
      }
      this.projectionDelta || (this.projectionDelta = j(), this.projectionDeltaWithTransform = j());
      const c = this.projectionTransform;
      L(this.projectionDelta, this.layoutCorrected, m, this.latestValues), this.projectionTransform = W(this.projectionDelta, this.treeScale), (this.projectionTransform !== c || this.treeScale.x !== n || this.treeScale.y !== l) && (this.hasProjected = !0, this.scheduleRender(), this.notifyListeners("projectionUpdate", m)), x.recalculatedProjection++;
    }
    hide() {
      this.isVisible = !1;
    }
    show() {
      this.isVisible = !0;
    }
    scheduleRender(t = !0) {
      if (this.options.scheduleRender && this.options.scheduleRender(), t) {
        const e = this.getStack();
        e && e.scheduleRender();
      }
      this.resumingFrom && !this.resumingFrom.instance && (this.resumingFrom = void 0);
    }
    setAnimationOrigin(t, e = !1) {
      const s = this.snapshot, o = s ? s.latestValues : {}, a = { ...this.latestValues }, r = j();
      (!this.relativeParent || !this.relativeParent.options.layoutRoot) && (this.relativeTarget = this.relativeTargetOrigin = void 0), this.attemptToResolveRelativeTarget = !e;
      const n = f(), l = s ? s.source : void 0, m = this.layout ? this.layout.source : void 0, c = l !== m, P = this.getStack(), T = !P || P.members.length <= 1, D = !!(c && !T && this.options.crossfade === !0 && !this.path.some(Ut));
      this.animationProgress = 0;
      let g;
      this.mixTargetDelta = (v) => {
        const R = v / 1e3;
        Z(r.x, t.x, R), Z(r.y, t.y, R), this.setTargetDelta(r), this.relativeTarget && this.relativeTargetOrigin && this.layout && this.relativeParent && this.relativeParent.layout && (A(n, this.layout.layoutBox, this.relativeParent.layout.layoutBox), Ft(this.relativeTarget, this.relativeTargetOrigin, n, R), g && ut(this.relativeTarget, g) && (this.isProjectionDirty = !1), g || (g = f()), p(g, this.relativeTarget)), c && (this.animationValues = a, ot(a, o, this.latestValues, R, D, T)), this.root.scheduleUpdateProjection(), this.scheduleRender(), this.animationProgress = R;
      }, this.mixTargetDelta(this.options.layoutRoot ? 1e3 : 0);
    }
    startAnimation(t) {
      this.notifyListeners("animationStart"), this.currentAnimation && this.currentAnimation.stop(), this.resumingFrom && this.resumingFrom.currentAnimation && this.resumingFrom.currentAnimation.stop(), this.pendingAnimation && (H(this.pendingAnimation), this.pendingAnimation = void 0), this.pendingAnimation = M.update(() => {
        O.hasAnimatedSinceResize = !0, this.currentAnimation = gt(0, G, {
          ...t,
          onUpdate: (e) => {
            this.mixTargetDelta(e), t.onUpdate && t.onUpdate(e);
          },
          onComplete: () => {
            t.onComplete && t.onComplete(), this.completeAnimation();
          }
        }), this.resumingFrom && (this.resumingFrom.currentAnimation = this.currentAnimation), this.pendingAnimation = void 0;
      });
    }
    completeAnimation() {
      this.resumingFrom && (this.resumingFrom.currentAnimation = void 0, this.resumingFrom.preserveOpacity = void 0);
      const t = this.getStack();
      t && t.exitAnimationComplete(), this.resumingFrom = this.currentAnimation = this.animationValues = void 0, this.notifyListeners("animationComplete");
    }
    finishAnimation() {
      this.currentAnimation && (this.mixTargetDelta && this.mixTargetDelta(G), this.currentAnimation.stop()), this.completeAnimation();
    }
    applyTransformsToTarget() {
      const t = this.getLead();
      let { targetWithTransforms: e, target: s, layout: o, latestValues: a } = t;
      if (!(!e || !s || !o)) {
        if (this !== t && this.layout && o && it(this.options.animationType, this.layout.layoutBox, o.layoutBox)) {
          s = this.target || f();
          const r = E(this.layout.layoutBox.x);
          s.x.min = t.target.x.min, s.x.max = s.x.min + r;
          const n = E(this.layout.layoutBox.y);
          s.y.min = t.target.y.min, s.y.max = s.y.min + n;
        }
        p(e, s), k(e, a), L(this.projectionDeltaWithTransform, this.layoutCorrected, e, a);
      }
    }
    registerSharedNode(t, e) {
      this.sharedNodes.has(t) || this.sharedNodes.set(t, new ct()), this.sharedNodes.get(t).add(e);
      const o = e.options.initialPromotionConfig;
      e.promote({
        transition: o ? o.transition : void 0,
        preserveFollowOpacity: o && o.shouldPreserveFollowOpacity ? o.shouldPreserveFollowOpacity(e) : void 0
      });
    }
    isLead() {
      const t = this.getStack();
      return t ? t.lead === this : !0;
    }
    getLead() {
      var t;
      const { layoutId: e } = this.options;
      return e ? ((t = this.getStack()) === null || t === void 0 ? void 0 : t.lead) || this : this;
    }
    getPrevLead() {
      var t;
      const { layoutId: e } = this.options;
      return e ? (t = this.getStack()) === null || t === void 0 ? void 0 : t.prevLead : void 0;
    }
    getStack() {
      const { layoutId: t } = this.options;
      if (t)
        return this.root.sharedNodes.get(t);
    }
    promote({ needsReset: t, transition: e, preserveFollowOpacity: s } = {}) {
      const o = this.getStack();
      o && o.promote(this, s), t && (this.projectionDelta = void 0, this.needsReset = !0), e && this.setOptions({ transition: e });
    }
    relegate() {
      const t = this.getStack();
      return t ? t.relegate(this) : !1;
    }
    resetRotation() {
      const { visualElement: t } = this.options;
      if (!t)
        return;
      let e = !1;
      const { latestValues: s } = t;
      if ((s.rotate || s.rotateX || s.rotateY || s.rotateZ) && (e = !0), !e)
        return;
      const o = {};
      for (let a = 0; a < q.length; a++) {
        const r = "rotate" + q[a];
        s[r] && (o[r] = s[r], t.setStaticValue(r, 0));
      }
      t.render();
      for (const a in o)
        t.setStaticValue(a, o[a]);
      t.scheduleRender();
    }
    getProjectionStyles(t = {}) {
      var e, s;
      const o = {};
      if (!this.instance || this.isSVG)
        return o;
      if (this.isVisible)
        o.visibility = "";
      else
        return { visibility: "hidden" };
      const a = this.getTransformTemplate();
      if (this.needsReset)
        return this.needsReset = !1, o.opacity = "", o.pointerEvents = C(t.pointerEvents) || "", o.transform = a ? a(this.latestValues, "") : "none", o;
      const r = this.getLead();
      if (!this.projectionDelta || !this.layout || !r.target) {
        const c = {};
        return this.options.layoutId && (c.opacity = this.latestValues.opacity !== void 0 ? this.latestValues.opacity : 1, c.pointerEvents = C(t.pointerEvents) || ""), this.hasProjected && !B(this.latestValues) && (c.transform = a ? a({}, "") : "none", this.hasProjected = !1), c;
      }
      const n = r.animationValues || r.latestValues;
      this.applyTransformsToTarget(), o.transform = W(this.projectionDeltaWithTransform, this.treeScale, n), a && (o.transform = a(n, o.transform));
      const { x: l, y: m } = this.projectionDelta;
      o.transformOrigin = `${l.origin * 100}% ${m.origin * 100}% 0`, r.animationValues ? o.opacity = r === this ? (s = (e = n.opacity) !== null && e !== void 0 ? e : this.latestValues.opacity) !== null && s !== void 0 ? s : 1 : this.preserveOpacity ? this.latestValues.opacity : n.opacityExit : o.opacity = r === this ? n.opacity !== void 0 ? n.opacity : "" : n.opacityExit !== void 0 ? n.opacityExit : 0;
      for (const c in N) {
        if (n[c] === void 0)
          continue;
        const { correct: P, applyTo: T } = N[c], D = o.transform === "none" ? n[c] : P(n[c], r);
        if (T) {
          const g = T.length;
          for (let v = 0; v < g; v++)
            o[T[v]] = D;
        } else
          o[c] = D;
      }
      return this.options.layoutId && (o.pointerEvents = r === this ? C(t.pointerEvents) || "" : "none"), o;
    }
    clearSnapshot() {
      this.resumeFrom = this.snapshot = void 0;
    }
    // Only run on root
    resetTree() {
      this.root.nodes.forEach((t) => {
        var e;
        return (e = t.currentAnimation) === null || e === void 0 ? void 0 : e.stop();
      }), this.root.nodes.forEach(X), this.root.sharedNodes.clear();
    }
  };
}
function Pt(i) {
  i.updateLayout();
}
function Dt(i) {
  var u;
  const h = ((u = i.resumeFrom) === null || u === void 0 ? void 0 : u.snapshot) || i.snapshot;
  if (i.isLead() && i.layout && h && i.hasListeners("didUpdate")) {
    const { layoutBox: d, measuredBox: V } = i.layout, { animationType: U } = i.options, t = h.source !== i.layout.source;
    U === "size" ? z((r) => {
      const n = t ? h.measuredBox[r] : h.layoutBox[r], l = E(n);
      n.min = d[r].min, n.max = n.min + l;
    }) : it(U, h.layoutBox, d) && z((r) => {
      const n = t ? h.measuredBox[r] : h.layoutBox[r], l = E(d[r]);
      n.max = n.min + l, i.relativeTarget && !i.currentAnimation && (i.isProjectionDirty = !0, i.relativeTarget[r].max = i.relativeTarget[r].min + l);
    });
    const e = j();
    L(e, d, h.layoutBox);
    const s = j();
    t ? L(s, i.applyTransform(V, !0), h.measuredBox) : L(s, d, h.layoutBox);
    const o = !et(e);
    let a = !1;
    if (!i.resumeFrom) {
      const r = i.getClosestProjectingParent();
      if (r && !r.resumeFrom) {
        const { snapshot: n, layout: l } = r;
        if (n && l) {
          const m = f();
          A(m, h.layoutBox, n.layoutBox);
          const c = f();
          A(c, d, l.layoutBox), tt(m, c) || (a = !0), r.options.layoutRoot && (i.relativeTarget = c, i.relativeTargetOrigin = m, i.relativeParent = r);
        }
      }
    }
    i.notifyListeners("didUpdate", {
      layout: d,
      snapshot: h,
      delta: s,
      layoutDelta: e,
      hasLayoutChanged: o,
      hasRelativeTargetChanged: a
    });
  } else if (i.isLead()) {
    const { onExitComplete: d } = i.options;
    d && d();
  }
  i.options.transition = void 0;
}
function St(i) {
  x.totalNodes++, i.parent && (i.isProjecting() || (i.isProjectionDirty = i.parent.isProjectionDirty), i.isSharedProjectionDirty || (i.isSharedProjectionDirty = !!(i.isProjectionDirty || i.parent.isProjectionDirty || i.parent.isSharedProjectionDirty)), i.isTransformDirty || (i.isTransformDirty = i.parent.isTransformDirty));
}
function Bt(i) {
  i.isProjectionDirty = i.isSharedProjectionDirty = i.isTransformDirty = !1;
}
function jt(i) {
  i.clearSnapshot();
}
function X(i) {
  i.clearMeasurements();
}
function Rt(i) {
  i.isLayoutDirty = !1;
}
function At(i) {
  const { visualElement: u } = i.options;
  u && u.getProps().onBeforeLayoutMeasure && u.notify("BeforeLayoutMeasure"), i.resetTransform();
}
function Y(i) {
  i.finishAnimation(), i.targetDelta = i.relativeTarget = i.target = void 0, i.isProjectionDirty = !0;
}
function Lt(i) {
  i.resolveTargetDelta();
}
function Vt(i) {
  i.calcProjection();
}
function kt(i) {
  i.resetRotation();
}
function Et(i) {
  i.removeLeadSnapshot();
}
function Z(i, u, h) {
  i.translate = F(u.translate, 0, h), i.scale = F(u.scale, 1, h), i.origin = u.origin, i.originPoint = u.originPoint;
}
function $(i, u, h, d) {
  i.min = F(u.min, h.min, d), i.max = F(u.max, h.max, d);
}
function Ft(i, u, h, d) {
  $(i.x, u.x, h.x, d), $(i.y, u.y, h.y, d);
}
function Ut(i) {
  return i.animationValues && i.animationValues.opacityExit !== void 0;
}
const Ct = {
  duration: 0.45,
  ease: [0.4, 0, 0.1, 1]
}, J = (i) => typeof navigator < "u" && navigator.userAgent.toLowerCase().includes(i), K = J("applewebkit/") && !J("chrome/") ? Math.round : Tt;
function Q(i) {
  i.min = K(i.min), i.max = K(i.max);
}
function Ot(i) {
  Q(i.x), Q(i.y);
}
function it(i, u, h) {
  return i === "position" || i === "preserve-aspect" && !lt(I(u), I(h), 0.2);
}
export {
  Bt as cleanDirtyNodes,
  le as createProjectionNode,
  $ as mixAxis,
  Z as mixAxisDelta,
  Ft as mixBox,
  St as propagateDirtyNodes
};
