import { isKeyframesTarget as C } from "../../../animation/utils/is-keyframes-target.mjs";
import { invariant as V } from "../../../utils/errors.mjs";
import { transformPropOrder as O } from "../../html/utils/transform.mjs";
import { findDimensionValueType as d } from "../value-types/dimensions.mjs";
import { isBrowser as P } from "../../../utils/is-browser.mjs";
import { number as v } from "../../../value/types/numbers/index.mjs";
import { px as w } from "../../../value/types/numbers/units.mjs";
const A = /* @__PURE__ */ new Set([
  "width",
  "height",
  "top",
  "left",
  "right",
  "bottom",
  "x",
  "y",
  "translateX",
  "translateY"
]), K = (e) => A.has(e), B = (e) => Object.keys(e).some(K), b = (e) => e === v || e === w, y = (e, o) => parseFloat(e.split(", ")[o]), F = (e, o) => (s, { transform: t }) => {
  if (t === "none" || !t)
    return 0;
  const p = t.match(/^matrix3d\((.+)\)$/);
  if (p)
    return y(p[1], o);
  {
    const m = t.match(/^matrix\((.+)\)$/);
    return m ? y(m[1], e) : 0;
  }
}, S = /* @__PURE__ */ new Set(["x", "y", "z"]), j = O.filter((e) => !S.has(e));
function Y(e) {
  const o = [];
  return j.forEach((s) => {
    const t = e.getValue(s);
    t !== void 0 && (o.push([s, t.get()]), t.set(s.startsWith("scale") ? 1 : 0));
  }), o.length && e.render(), o;
}
const u = {
  // Dimensions
  width: ({ x: e }, { paddingLeft: o = "0", paddingRight: s = "0" }) => e.max - e.min - parseFloat(o) - parseFloat(s),
  height: ({ y: e }, { paddingTop: o = "0", paddingBottom: s = "0" }) => e.max - e.min - parseFloat(o) - parseFloat(s),
  top: (e, { top: o }) => parseFloat(o),
  left: (e, { left: o }) => parseFloat(o),
  bottom: ({ y: e }, { top: o }) => parseFloat(o) + (e.max - e.min),
  right: ({ x: e }, { left: o }) => parseFloat(o) + (e.max - e.min),
  // Transform
  x: F(4, 13),
  y: F(5, 14)
};
u.translateX = u.x;
u.translateY = u.y;
const _ = (e, o, s) => {
  const t = o.measureViewportBox(), p = o.current, m = getComputedStyle(p), { display: x } = m, c = {};
  x === "none" && o.setStaticValue("display", e.display || "block"), s.forEach((a) => {
    c[a] = u[a](t, m);
  }), o.render();
  const r = o.measureViewportBox();
  return s.forEach((a) => {
    const l = o.getValue(a);
    l && l.jump(c[a]), e[a] = u[a](r, m);
  }), e;
}, M = (e, o, s = {}, t = {}) => {
  o = { ...o }, t = { ...t };
  const p = Object.keys(o).filter(K);
  let m = [], x = !1;
  const c = [];
  if (p.forEach((r) => {
    const a = e.getValue(r);
    if (!e.hasValue(r))
      return;
    let l = s[r], f = d(l);
    const n = o[r];
    let i;
    if (C(n)) {
      const T = n.length, g = n[0] === null ? 1 : 0;
      l = n[g], f = d(l);
      for (let h = g; h < T && n[h] !== null; h++)
        i ? V(d(n[h]) === i, "All keyframes must be of the same type") : (i = d(n[h]), V(i === f || b(f) && b(i), "Keyframes must be of the same dimension as the current value"));
    } else
      i = d(n);
    if (f !== i)
      if (b(f) && b(i)) {
        const T = a.get();
        typeof T == "string" && a.set(parseFloat(T)), typeof n == "string" ? o[r] = parseFloat(n) : Array.isArray(n) && i === w && (o[r] = n.map(parseFloat));
      } else
        f != null && f.transform && (i != null && i.transform) && (l === 0 || n === 0) ? l === 0 ? a.set(i.transform(l)) : o[r] = f.transform(n) : (x || (m = Y(e), x = !0), c.push(r), t[r] = t[r] !== void 0 ? t[r] : o[r], a.jump(n));
  }), c.length) {
    const r = c.indexOf("height") >= 0 ? window.pageYOffset : null, a = _(o, e, c);
    return m.length && m.forEach(([l, f]) => {
      e.getValue(l).set(f);
    }), e.render(), P && r !== null && window.scrollTo({ top: r }), { target: a, transitionEnd: t };
  } else
    return { target: o, transitionEnd: t };
};
function W(e, o, s, t) {
  return B(o) ? M(e, o, s, t) : { target: o, transitionEnd: t };
}
export {
  u as positionalValues,
  W as unitConversion
};
